/**
 ##############################################################################
 # Copyright (C) 2006-2010 INRIA
 #
 # This library is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 2 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with this library; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ##############################################################################
 * 
 */
package fr.inria.icocoa.junittest.servicemodel;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import fr.inria.icocoa.servicemodel.ControlConstruct;

/**
 * ControlConstructTest.java<br>
 * 
 * This class contains tests for the class
 * {@link fr.inria.icocoa.servicemodel.ControlConstruct}
 * 
 * @author <a href="mailto:sebastien.bianco@inria.fr">sebastien bianco</a> - <a
 *         href="http://www-rocq.inria.fr/arles">Arles Project - INRIA</a>
 * 
 * Creation Date : Apr 17, 2007 3:01:32 PM
 */
public class ControlConstructTest {

	/**
	 * Test method for
	 * {@link fr.inria.icocoa.servicemodel.ControlConstruct#hashCode()}.
	 */
	@Test
	public final void testHashCode() {
		ControlConstruct in = new ControlConstruct(0);
		ControlConstruct in2 = new ControlConstruct(0);
		assertEquals("testHashCode : same hashCode", true, in.hashCode() == in2
				.hashCode());

		ControlConstruct in3 = new ControlConstruct(2);
		ControlConstruct in4 = new ControlConstruct(3);
		assertEquals("testHashCode : different hashCode", false,
				in3.hashCode() == in4.hashCode());
	}

	/**
	 * Test method for
	 * {@link fr.inria.icocoa.servicemodel.ControlConstruct#equals(java.lang.Object)}.
	 */
	@Test
	public final void testEqualsObject() {
		ControlConstruct in = new ControlConstruct(0);
		ControlConstruct in2 = ControlConstruct.SEQUENCE;
		ControlConstruct in3 = ControlConstruct.CHOICE;
		ControlConstruct in4 = ControlConstruct.SEQUENCE;

		// equals
		assertEquals("testEqualsObject : same object", true, in.equals(in));
		assertEquals("testEqualsObject : same semantic", true, in.equals(in2));
		assertEquals("testEqualsObject : same semantic 2", true, in2
				.equals(in4));
		assertEquals("testEqualsObject : same reference", true, in == in);
		assertEquals("testEqualsObject : same reference 2", true, in2 == in4);

		// not equals
		assertEquals("testEqualsObject : not same reference", true, in != in2);
		assertEquals("testEqualsObject : not same semantic 1", false, in
				.equals(in3));
		assertEquals("testEqualsObject : not same semantic 2", false, in2
				.equals(in3));
	}

}
